import { Client } from '../Client';
import { Resource } from '../Resource';
import { DuffelResponse, PaginationMeta } from '../types';
import { CustomerUserGroup, CustomerUserGroupPayload } from './IdentityTypes';
export declare class CustomerUserGroups extends Resource {
    /**
     * Endpoint path
     */
    path: string;
    constructor(client: Client);
    /**
     * Retrieves a list of customer user groups
     */
    list: (options?: PaginationMeta) => Promise<DuffelResponse<CustomerUserGroup[]>>;
    /**
     * Creates a customer user group for the organisation.
     */
    create: (data: CustomerUserGroupPayload) => Promise<DuffelResponse<CustomerUserGroup>>;
    /**
     * Deletes a customer user group by its ID
     */
    delete: (id: CustomerUserGroup["id"]) => Promise<DuffelResponse<CustomerUserGroup>>;
    /**
     * Retrieves an customer user group by its ID
     */
    get: (id: CustomerUserGroup["id"]) => Promise<DuffelResponse<CustomerUserGroup>>;
    /**
     * Updates an customer user group by its ID
     */
    update: (id: CustomerUserGroup["id"], data: CustomerUserGroupPayload) => Promise<DuffelResponse<CustomerUserGroup>>;
}
