import { Client } from '../Client';
import { Resource } from '../Resource';
import { DuffelResponse, PaginationMeta } from '../types';
import { CustomerUser, CustomerUserPayload } from './IdentityTypes';
export declare class CustomerUsers extends Resource {
    /**
     * Endpoint path
     */
    path: string;
    constructor(client: Client);
    /**
     * Creates a customer user for the organisation.
     */
    create: (data: CustomerUserPayload) => Promise<DuffelResponse<CustomerUser>>;
    /**
     * Retrieves an customer user by its ID
     */
    get: (id: CustomerUser["id"]) => Promise<DuffelResponse<CustomerUser>>;
    /**
     * Updates a customer user based on provided ID
     */
    update: (id: CustomerUser["id"], data: CustomerUserPayload) => Promise<DuffelResponse<CustomerUser>>;
    /**
     * Retrieves a list of customer user groups
     * Allows filtering by email
  
     */
    list: (options?: PaginationMeta & {
        email?: string;
    }) => Promise<DuffelResponse<CustomerUser[]>>;
}
