import { Client } from '../../Client';
import { StaysQuote } from '../StaysTypes';
import { Resource } from '../../Resource';
import { DuffelResponse } from '../../types';
export declare class Quotes extends Resource {
    /**
     * Endpoint path
     */
    path: string;
    constructor(client: Client);
    /**
     * Create a quote for the selected rate
     * @param {string} quoteId - The ID of the rate to create a quote for
     */
    get: (quoteId: string) => Promise<DuffelResponse<StaysQuote>>;
    /**
     * Create a quote for the selected rate
     * @param {string} rateId - The ID of the rate to create a quote for
     */
    create: (rateId: string) => Promise<DuffelResponse<StaysQuote>>;
}
