import { Client } from '../Client';
import { StaysSearchParams, StaysSearchResponse } from './StaysTypes';
import { Resource } from '../Resource';
import { DuffelResponse } from '../types';
import { Accommodation } from './Accommodation';
import { Brands } from './Brands';
import { LoyaltyProgrammes } from './LoyaltyProgrammes';
import { Bookings } from './Bookings';
import { Quotes } from './Quotes';
import { SearchResults } from './SearchResults';
export declare class Stays extends Resource {
    /**
     * Endpoint path
     */
    path: string;
    accommodation: Accommodation;
    loyaltyProgrammes: LoyaltyProgrammes;
    brands: Brands;
    searchResults: SearchResults;
    quotes: Quotes;
    bookings: Bookings;
    constructor(client: Client);
    /**
     * Search for accommodations
     * @param {object} params - The search parameters
     */
    search: (params: StaysSearchParams) => Promise<DuffelResponse<StaysSearchResponse>>;
}
