/**
 * Airlines are used to identify the air travel companies selling and operating flights
 * @link https://duffel.com/docs/api/airlines/schema
 */
export interface Airline {
    /**
     * The three-character IATA code for the airline
     */
    name: string;
    /**
     * Duffel's unique identifier for the airline
     */
    id: string;
    iata_code: string | null;
    logo_lockup_url: string | null;
    logo_symbol_url: string | null;
    conditions_of_carriage_url: string | null;
}
